<template>
  <div>
    <h1>Password Reset</h1>
    <b-alert
      v-model="showAlert"
      :variant="alertVariety"
      class="mt-2 mb-2"
      dismissible
    >
      {{
        alertMessage
      }}
    </b-alert>
    <b-form @submit.prevent="changePassword">
      <b-form-group
        class="mt-2"
        label="New Password"
      >
        <b-form-input
          v-model="password"
          :disabled="submitting"
          :state="$v.password.$dirty ? ($v.password.$invalid ? false : true) : null"
          placeholder="Enter a new password"
          type="password"
          @change="$v.password.$touch"
        />
        <b-form-text v-if="!$v.password.$dirty || !$v.password.$invalid">
          Your password must contain at least 8 characters.
        </b-form-text>
        <b-form-invalid-feedback v-else-if="!$v.password.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.password.minLength || !$v.password.maxLength">
          Field must have between 8 and 256 characters.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.password.specialCharacters">
          Field must contain at least one number and one uppercase letter.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Cofirm New Password">
        <b-form-input
          v-model="repeatPassword"
          :disabled="submitting"
          :state="$v.repeatPassword.$dirty ? ($v.repeatPassword.$invalid ? false : true) : null"
          placeholder="Enter the same password"
          type="password"
          @change="$v.repeatPassword.$touch"
        />
        <b-form-text v-if="!$v.repeatPassword.$dirty || !$v.repeatPassword.$invalid" />
        <b-form-invalid-feedback v-else-if="!$v.repeatPassword.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.repeatPassword.sameAsPassword">
          Field doesn't match password.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-button
        :disabled="$v.password.$invalid || $v.repeatPassword.$invalid || submitting"
        block
        class="mb-2"
        type="submit"
        variant="success"
      >
        Change Password
      </b-button>
    </b-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import {
  maxLength, minLength, required, sameAs,
} from 'vuelidate/lib/validators';

import { AuthService } from '@/api';

export default Vue.extend({
  props: {
    token: {
      required: true,
      type: String,
    },
  },

  data() {
    return {
      submitting: false,
      password: '',
      repeatPassword: '',
      showAlert: false,
      alertMessage: '',
      alertVariety: '',
    };
  },

  validations: {
    password: {
      minLength: minLength(8),
      maxLength: maxLength(256),
      specialCharacters: (password) => {
        if (!/[A-Z]/.test(password)) {
          return false;
        }
        if (!/\d/.test(password)) {
          return false;
        }
        return true;
      },
      required,
    },
    repeatPassword: {
      sameAsPassword: sameAs('password'),
      required,
    },
  },

  methods: {
    alert(message: string, variety: string) {
      this.alertMessage = message;
      this.alertVariety = variety;
      this.showAlert = true;
    },
    async changePassword() {
      this.submitting = true;
      try {
        await AuthService.resetPasswordWithToken(this.password, this.token);
      } catch (error) {
        this.$emit('failure');
        return;
      } finally {
        this.submitting = false;
      }
      this.$emit('success');
    },
  },
});
</script>
